function w=LuDebSinha2016b_ver4(x,y,keyf,keyxy)
% This file provides all functions defining LuDebSinha16a problem 
% and their first and second order derivatives.
% [dim_x dim_y dim_G dim_g] = [1 1 4 0]


if nargin<4 || isempty(keyxy)
    switch keyf
    case 'F'; w = (x-0.5)^2+(y-1)^2;
    case 'G'; w = [-x; x-1; -y; y-2];
    case 'f'; a = (1.5*y-x)/0.055;
              w = 2-exp(-a^0.4 )-0.8*exp(-( (2*y+x-3)/0.5 )^2 );         
    case 'g'; w = [];  
    end    
else
    switch keyf        
    case 'F'
        switch keyxy
        case 'x' ; w = 2*(x-0.5);         
        case 'y' ; w = 2*(y-1);   
        case 'xx'; w = 2;
        case 'xy'; w = 0;
        case 'yy'; w = 2;
        end 
    case 'G'  
        switch keyxy            
        case 'x' ; w = [-1;1;0;0];    
        case 'y' ; w = [ 0;0;-1;1];       
        case 'xx'; w = zeros(4,1);
        case 'xy'; w = zeros(4,1);
        case 'yy'; w = zeros(4,1);
        end                    
	case 'g'   
        switch keyxy
        case 'x' ; w = [];    
        case 'y' ; w = [];       
        case 'xx'; w = [];
        case 'xy'; w = [];
        case 'yy'; w = [];       
        case 'yxx'; w = [];
        case 'yxy'; w = [];
        case 'yyy'; w = [];
        end        
   end   
end
w = real(w);
end

